# 多sheet懒加载插件
**特性：**第一次只会计算第一个sheet，后台计算也是如此，后续点击一个sheet再去计算一个sheet，解决sheet过多时计算比较慢的问题，缺点是无法处理sheet间运算。如下图所示，点击“懒加载多sheet”即可看到效果：
![lazy](screenshots/lazy_preview.png)


下面来看一下测试结果，现有一张多sheet报表，分别有两个数据集ds1和ds2，ds1用在sheet1中，ds2用在sheet2中，分别看一下一般的```op=view```预览方式和加了插件后的```op=view&__lazy__==true```的预览结果:

* 普通的```op=view```方式，可以看到ds1和ds2同时都参与了运算
![normal](screenshots/normal.png)

* 加了插件后的懒加载sheet方式```op=view&__lazy__==true```，可以看到预览sheet1的时候，只有ds1参与了运算
![lazy](screenshots/lazy.png)
