package com.fr.plugin.lazy.sheet;

import com.fr.plugin.lazy.sheet.fun.LazySheetViewActor;
import com.fr.plugin.lazy.sheet.fun.LazySheetWriteActor;
import com.fr.report.fun.impl.AbstractActorProvider;
import com.fr.report.stable.fun.Actor;

/**
 * Created by richie on 15/7/17.
 */
public class LazySheetActorBridge extends AbstractActorProvider {

    @Override
    public int currentAPILevel() {
        return CURRENT_LEVEL;
    }

    @Override
    public Actor[] createActor() {
        return new Actor[]{
                new LazySheetViewActor(),
                new LazySheetWriteActor()
        };
    }
}