package com.fr.plugin.lazy.sheet;

import com.fanruan.api.i18n.I18nKit;
import com.fr.design.fun.impl.AbstractPreviewProvider;

import java.util.HashMap;
import java.util.Map;

/**
 * Created by richie on 15/7/17.
 */
public class LazySheetPreviewBridge extends AbstractPreviewProvider {

    @Override
    public int currentAPILevel() {
        return CURRENT_LEVEL;
    }

    public String iconPathForPopupItem() {
        return "com/fr/design/images/buttonicon/anas.png";
    }

    public String iconPathForLarge() {
        return "com/fr/design/images/buttonicon/anab24.png";
    }

    @Override
    public String nameForPopupItem() {
        return I18nKit.getLocText("Plugin-Lazy_Load_Preview");
    }

    @Override
    public int previewTypeCode() {
        return 18;
    }

    @Override
    public Map<String, Object> parametersForPreview() {
        Map<String, Object> map = new HashMap<String, Object>();
        map.put("op", "view");
        map.put("__lazy__", true);
        return map;
    }
}